bbc.fmtj.utils.createObject('bbc.fmtj.apps.election2010.indexModule');
gloader.load(['glow', '1.7', 'glow.dom', 'glow.anim', 'glow.embed', 'glow.tweens', 'glow.net', 'glow.widgets.AutoSuggest', 'glow.widgets.InfoPanel'],{
	async: false,
	onLoad: function(glow) {
		window.onerror = function() { return true; };
		var mainWrapper = glow.dom.get('#elec-results-module'),
			parties = glow.dom.get('#elec-results-module .party'),
			interval,
			partyName = { CON: 'Conservative', LAB: 'Labour', LD: 'Liberal Democrat' },
			DATA_PERIOD = 30000,
			cdnurl = 'cdnedge.bbc.co.uk',
			previousData = '',
			predSeatsScale = 2.17,
			flashTicker,
			initialLoad = true,
			swf = "http://newsimg.bbc.co.uk/nol/shared/election2010/results/9_0/swf/latest_result.swf",
			swfWidth = "388px";
		
		bbc.fmtj.apps.election2010.indexModule = (function() {
			if(document.getElementById('small-results-module')) {
				partyName.LD = 'Lib Dem';
			}
			
			if(document.getElementById('story-results-module')) {
				swf = "http://newsimg.bbc.co.uk/nol/shared/election2010/results/9_0/swf/latest_result_story.swf";
				swfWidth = "204px";
			}
			
			if(document.getElementById('index-results-module')) {
				predSeatsScale = 2.67;
			}
			
			// init creates an object for the external interface.
			return init();
		}());
				
		function init() {
			setupDataReq();
			flashTicker = new glow.embed.Flash(
				swf,
				"div#latest-results",
				"9",
				{
					message: "",
					width: swfWidth,
					height: "24px"
				}
			);
			flashTicker.embed();
			
			// for access of the request
			return {
				loadData: loadData
			};
		}
		
		function setupDataReq() {
			clearInterval(interval);
			interval = loadScript(
				'/nol/shared/election2010/results/national/json/mini_winningposts.sjson',
				'bbc.fmtj.apps.election2010.indexModule.loadData',
				DATA_PERIOD,
				true
			);
		}
		
		/* Load some data */
		function loadData(data) {
			// {
				// results: 
				// ['CON|283|76|2|+74|10,018,183|34.4|+2.0|157|18',
				//  'LAB|265|1|85|-84|8,714,818|29.9|-5.4|147|6',
				//  'LD|68|10|4|+6|6,857,012|23.5|+1.5|37|16',''],
				// totalSeats: 649,
				// 'refreshdetails': ['15', 'nolqa40.newsonline.tc.nca.bbc.co.uk']
			// }
			if(!(data && data.refreshdetails)) {
				return;
			}
		
			var d, el, elLeaderImg, predWidth, seatWidth,
				newData = data.results.join('+') + data.totalSeats + data.refreshdetails.join('+');
			
			// if we have the same data do nothing.
			if(newData == previousData) {
				return;
			}
			previousData = newData;
			
			if(!initialLoad) {
				try {
					flashTicker.movie.jsGetUpcomingResults();
				} catch(e) {
					// somethign went wrong.
				}
			}
			initialLoad = false;
			
			if(DATA_PERIOD != parseInt(data.refreshdetails[0]) * 1000 || cdnurl != data.refreshdetails[1]) {
				DATA_PERIOD = parseInt(data.refreshdetails[0]) * 1000;
				cdnurl = data.refreshdetails[1];
				setupDataReq();
			}
			
			glow.lang.map(data.results, function(row, i) {
				d = row.split('|');
				if(d.length > 1) {
					// update classname
					el = parties.item(i); // dom el, turned into a NodeList below
					el.className = el.className.replace(/party-([A-Z])+/g, 'party-' + d[0]);
					
					// turn our object into glow for some fun
					el = glow.dom.get(el);
					el.get('.party-name').html(partyName[d[0]]);
					elLeaderImg = el.get('.leader-img');
					if(elLeaderImg.length > 0) {
						elLeaderImg.item(0).src = '/nol/shared/election2010/img/results_module/' + d[0].toLowerCase() + '_leader_60x40.jpg';
					}
					animateIncrement(el.get('.seats').item(0), d[1]);

					el.get('.seats-change').html(d[4]);
					el.get('.vote-share').html(d[6]);
					
					predWidth = Math.round(parseInt(d[9])/predSeatsScale);
					seatWidth = Math.round(parseInt(d[1])/predSeatsScale);
					
					glow.anim.css(el.get('.seats-bar'), 1, { width: { to: seatWidth + 'px' } }).start();
					glow.anim.css(el.get('.predictions-bar'), 2, { width: { to: predWidth + 'px' } }).start();
				}
				
				return true;
			});
			
			mainWrapper.get('.results-declared').html(data.totalSeats);
		}
		
		/* PRIVATE STUFFS */
		function loadScript(url, callback, interval, callImmediately) {
			var reqFunc = function() {
				var req = glow.net.loadScript('http://' + cdnurl + url + '?jsoncallback='+callback+'&cachebuster=cb'+new Date().getTime(), {
					useCache: true
				});
				// remove any script nodes afer 60s
				setTimeout(function() {
					req.destroy();
				}, 60000);
			};
			
			if(!interval || callImmediately) {
				reqFunc();
			} 
			
			if(interval && interval > 0) {
				return setInterval(reqFunc, interval);
			}
		}
			
		function animateIncrement(el, val, hasCommas, hasPlus, hasPoint, timeout) {			
			if(hasPoint == true) {
				el.innerHTML = val;
				return;
			}
			if(hasCommas == true) {
				el.innerHTML = val;
				return;
			}
			var toVal = getNum(val),
				fromVal = getNum(el.innerHTML),
				intermediateVal,
				diff = toVal - fromVal;
			if(!timeout) {
				var timeout;
			}
			if(Math.abs(diff) > 1) {
				intermediateVal = fromVal + 1;
				if(hasPlus) {
					intermediateVal = '+' + intermediateVal;
				}
				
				if(intermediateVal >= toVal) {
					el.innerHTML = toVal;
					clearTimeout(timeout);
					return;
				}
				
				el.innerHTML = intermediateVal;
				timeout = setTimeout( function() {
					animateIncrement(el, val, hasCommas, hasPlus, hasPoint, timeout);
				}, Math.round((1/diff)*1000));
			} else {
				// we reached our target
				el.innerHTML = toVal;
				clearTimeout(timeout);
			}
		}
		
		function getNum(val) {
			var ret;
			if(val && val.indexOf && val.indexOf(',') !== -1) {
				ret = parseFloat(('' + val).replace(/\,/g, ''));
			} else {
				ret = parseFloat(val);
			}
			
			return (isNaN(ret)) ? 0 : ret;
		}
		
		function addCommas(nStr){
			nStr += '';
			x = nStr.split('.');
			x1 = x[0];
			x2 = x.length > 1 ? '.' + x[1] : '';
			var rgx = /(\d+)(\d{3})/;
			while (rgx.test(x1)) {
				x1 = x1.replace(rgx, '$1' + ',' + '$2');
			}
			return x1 + x2;
		}
		
		function html_entity_decode(str) {
			// reused TA from closure above, no need to recreate it every time
			ta.innerHTML=str.replace(/</g,"&lt;").replace(/>/g,"&gt;");
			return ta.value;
		}

	}
});