gloader.load(['glow', '1.7', 'glow.dom', 'glow.anim', 'glow.tweens', 'glow.net'],{
	async: false,
	onLoad: function(glow) {
		/* PRIVATE */
		var ANIM_PERIOD = 10000,
			DATA_PERIOD = 8000,
			EVENT_PERIOD  = 4000,
			loadCount = 0,
			requestList = [],
			truncate = function(trunc, len) {
				if(!len) {
					len = 150;
				}
				if (trunc && trunc.length && trunc.length > len) {
					/* Truncate the content of the P, then go back to the end of the
					   previous word to ensure that we don't truncate in the middle of
					   a word */
					trunc = trunc.substring(0, len);
					trunc = trunc.replace(/\w+$/, '');

					/* Add an ellipses to the end and make it a link that expands
					   the paragraph back to its original size */
					return glow.lang.trim(trunc) + '&hellip;';
				}
				return trunc;
			},

			priv = {
				currentItemTime: null,
				animInterval: null,
				dataInterval: null,				
				inVideoAnim: false,
				initialLoad: true,
				videoAnim: null,
				currentText: null,
				getData: function() {
					var req = glow.net.loadScript('http://cdnedge.bbc.co.uk/nol/shared/election2010/liveevent/json/latestonly.sjson?jsoncallback=bbc.fmtj.apps.election2010.liveEvent.promo.loadData&cachebuster=cb'+new Date().getTime(), {
						useCache: true
					});
					
					// remove any script nodes afer 60s
					setTimeout(function() {
						req.destroy();
					}, 60000);
				},
				animateVideo: function() {
					if(!priv.initialLoad) {
						// we need to make certain we have the latest list here items list
						priv.items = glow.dom.get('.video-live li');
						var item = glow.dom.get(priv.items.item(0));
						if(priv.items.length > 1) {
							priv.videoAnim = glow.anim.css(
								item.parent(), 1.2, 
								{ left: { to: -653 } },
								{ tween: glow.tweens.easeIn() }
							);
							glow.events.addListener(priv.videoAnim, "complete", function() {
								var parent = item.parent();
								parent.css('left', 0);
								item.remove();

								// if this item has not been outdated append it to the page
								if(!item.hasClass('old')) {
									parent.append(item);
								} else {
									item.destroy();
								}
							});
							priv.videoAnim.start();
						}
					}
				},
				animateEvent: function(doAnim) {
					if(priv.newEventHtml && priv.newEventHtml.length > 0) {
						var el = glow.dom.get('.event-live > div'),
							elLi = el.get('li');
							
						if(doAnim) {
							glow.anim.fadeOut(el.parent(), 1, {
								onComplete: function() {
									// replace the current class
									elLi.replaceWith(priv.newEventHtml);
									elLi.item(0).className = 'type-'+priv.newEventType;
									// insert elements we need
									priv.insertTime();
									priv.insertTypeText();
									
									glow.anim.fadeIn(el.parent(), 1, {
										onComplete: function() {
											var el1 = el.parent().item(0);
											if(el1.style && el1.style['filter']) {
												el1.style['filter'] = 'none';
											}
										}
									});
									priv.newEventHtml = false;
								}
							});
						} else {
							elLi.replaceWith(priv.newEventHtml);
							priv.insertTime();
							priv.insertTypeText();
							priv.newEventHtml = false;
						}
					}
				},
				insertTime: function() {
					// add the time
					// calc time
					var time = (parseInt(priv.currentTime) - parseInt(priv.currentItemTime)),
						timeEl;
						
					if(time > 3599) {
						time = ' ';		
					}
					else if(time > 59) {
						time = Math.round(time/60) + ' mins ago';
					} 
					else if(time == 1) {
						time = Math.round(time) + ' sec ago';
					}
					else if(time > 0) {
						time = Math.round(time) + ' secs ago';
					}
					
					if(time < 0) {
						time = 'less than a second ago';
					}
					
					// time ago stuff happened
					glow.dom.get('.event-live strong.time').remove();
					var showTime = true;
					if (bbc.fmtj.apps.election2010.liveEvent.typeLookup[priv.newEventType]) {
						showTime = bbc.fmtj.apps.election2010.liveEvent.typeLookup[priv.newEventType].st;
					}
					if(time && showTime) {
						timeEl = glow.dom.create('<strong class="time">'+time+'</strong>');
						glow.dom.get('.event-live').append(timeEl);
					}
				},
				insertTypeText: function() {
					// find the type
					var li = glow.dom.get('.event-live ol li').item(0),
						className,
						text,
						matches;
					
					if(li) {
						className = li.className;
						matches = className.match(/type-(\d+)/);
						 
						if(matches && matches[1] && bbc.fmtj.apps.election2010.liveEvent.typeLookup[matches[1]]) {
							text = bbc.fmtj.apps.election2010.liveEvent.typeLookup[matches[1]].t;
						}

					}
					
					glow.dom.get('.event-live strong.type-text').remove();
					if(text) {
						textEl = glow.dom.create('<strong class="type-text">'+text+'</strong>');
						glow.dom.get('.event-live').append(textEl);
					}
				},
				insertData: function(data) {
					if(data.startTime > data.UpdateTime) {
						if(data.videos.length > 0) {
							// we definitely have new data to add, therefore mark current data as being old
							// it will then be removed in the next animation
							priv.items = glow.dom.get('.video-live li');
							priv.items.addClass('old');
							var status = '';

							// vids 
							for(var i in data.videos) {
								status = (data.videos[i].state == 'livenow') ? 'Now' : 'Coming Up';
								glow.dom.create('<li class="coming"><h4>'+status+':</h4><p>'+data.videos[i].text+'</p></li>').appendTo('.video-live ol');
							}
							
						}
						
						// update the items in the carousel
						priv.currentItemTime = data.UpdateTime;
						priv.currentTime = data.startTime;

						if(data.events.length > 0 && data.events[0].text != priv.currentText) {
							priv.currentText = data.events[0].text;
							priv.newEventType = data.events[0].type;
							if(priv.newEventType && bbc.fmtj.apps.election2010.liveEvent.typeLookup[priv.newEventType]) {
								var len = bbc.fmtj.apps.election2010.liveEvent.typeLookup[priv.newEventType].l;
							}
							priv.newEventHtml = glow.dom.create('<li class="type-'+priv.newEventType+'"><div class="live-page-wrapper"><div class="lp-wrap"><div><strong>'+data.events[0].time+'</strong><p>'+truncate(data.events[0].text, len)+'</p></div></div></div></li>');
							if(priv.initialLoad) {
								priv.animateEvent(false);
								priv.insertTime();
								priv.insertTypeText();
							}
						}
					}
				}
			};
		
		/* NAMESPACED, PUBLIC */
		bbc.fmtj.apps.election2010.liveEvent.promo = function(){
			var pub = {
				init: function() {
					priv.currentItemTime = 0;
					priv.items = glow.dom.get('.video-live li');
					priv.items.each(function() {
						// remove broken items
						if(this.id == 'id_##id##') {
							glow.dom.get(this).remove();
						}
					});
					priv.getData();
					priv.animateVideo();
					priv.dataInterval = setInterval(priv.getData, DATA_PERIOD);
					priv.animInterval = setInterval(priv.animateVideo, ANIM_PERIOD);
					priv.animInterval = setInterval(function() { priv.animateEvent(true); }, EVENT_PERIOD);
				},
				loadData: function(data) {
					// we can delete and script nodes using destroy
					for(var i = 0, j = requestList.length; i < j; i++) {
						// remove the request item and destroy it
						requestList.pop().destroy(); // NOTE: doesn't seem to actually work
					}				
					// only insert on more recent update times
					if(priv.currentItemTime < data.UpdateTime) {
						priv.insertData(data);
						priv.initialLoad = false;
					}
				}
			};
			return pub;
		}();
		// init our app
		bbc.fmtj.apps.election2010.liveEvent.promo.init();
	}
});
